//Advance Spring Tricks by TGTLS
//Edited by GLide KS for Pizza Time Spice Runners

//needed it's own lua because srb2 hates me and it did not want to work
//orginally gonna have sonic advance spring trick sprites. Gonna have to add that in a update because blua is a FUCKING BITCH and didn't want to add the mobj
freeslot(
	"sfx_advtr",
	"MT_SPRINGTRICKWAVE",
	"SPR_TRWA",
	"S_TRICKWAVE1",
	"S_TRICKWAVE2",
	"S_TRICKWAVE3",
	"S_TRICKWAVE4",
	"S_TRICKWAVE5",
	"S_TRICKWAVE6",
	"S_TRICKWAVE7",
	"S_TRICKWAVE8",
	"S_PLAY_TRICKROLL",
	"S_PLAY_TRICKFALL"
)
sfxinfo[sfx_advtr].caption = "Spring Trick"

mobjinfo[MT_SPRINGTRICKWAVE] = {
	doomednum = -1,
	spawnstate = S_TRICKWAVE1,
	flags = MF_SCENERY|MF_NOBLOCKMAP|MF_NOCLIP|MF_NOCLIPHEIGHT
}

states[S_TRICKWAVE1] = {
	sprite = SPR_TRWA,
	frame = A|FF_ANIMATE,
	action = A_CapeChase,
	tics = 1,
	nextstate = S_TRICKWAVE2
}

states[S_TRICKWAVE2] = {
	sprite = SPR_TRWA,
	frame = B|FF_ANIMATE,
	action = A_CapeChase,
	tics = 1,
	nextstate = S_TRICKWAVE3
}

states[S_TRICKWAVE3] = {
	sprite = SPR_TRWA,
	frame = C|FF_ANIMATE,
	action = A_CapeChase,
	tics = 1,
	nextstate = S_TRICKWAVE4
}

states[S_TRICKWAVE4] = {
	sprite = SPR_TRWA,
	frame = D|FF_ANIMATE,
	action = A_CapeChase,
	tics = 1,
	nextstate = S_TRICKWAVE5
}

states[S_TRICKWAVE5] = {
	sprite = SPR_TRWA,
	frame = E|FF_ANIMATE,
	action = A_CapeChase,
	tics = 1,
	nextstate = S_TRICKWAVE6
}

states[S_TRICKWAVE6] = {
	sprite = SPR_TRWA,
	frame = F|FF_ANIMATE,
	action = A_CapeChase,
	tics = 1,
	nextstate = S_TRICKWAVE7
}

states[S_TRICKWAVE7] = {
	sprite = SPR_TRWA,
	frame = G|FF_ANIMATE,
	action = A_CapeChase,
	tics = 1,
	nextstate = S_TRICKWAVE8
}

states[S_TRICKWAVE8] = {
	sprite = SPR_TRWA,
	frame = H|FF_ANIMATE,
	action = A_CapeChase,
	tics = 1,
	nextstate = S_TRICKWAVE1
}

states[S_PLAY_TRICKROLL] = {
	sprite = SPR_PLAY,
	frame = SPR2_ROLL|FF_ANIMATE,
	tics = 10,
	var1 = 5,
	var2 = 2,
	nextstate = S_PLAY_TRICKFALL
}

states[S_PLAY_TRICKFALL] = {
	sprite = SPR_PLAY,
	frame = SPR2_FALL,
	tics = 2,
	nextstate = S_PLAY_TRICKFALL
}

addHook("PlayerThink", function(p) //from modded vanilla chars
	if p.c1tics == nil
		p.c1tics = 0
	end
end)	

addHook("PlayerThink", function(p) //from modded vanilla chars
	if (p.cmd.buttons & BT_CUSTOM1)
		p.c1tics = $1+1
	else
		p.c1tics = 0
	end
end)

addHook("PlayerThink", function(p) //from modded vanilla chars
	if p.mo and p.mo.valid
	if (p.mo.eflags & MFE_SPRUNG or p.powers[pw_justsprung])
	and (p.mo.state == S_PLAY_SPRING or p.mo.state == S_PLAY_FALL)
		p.sprung = true
	elseif (p.mo.eflags & MFE_JUSTHITFLOOR or P_IsObjectOnGround(p.mo))
		p.sprung = false
	end
	if (p.mo.state == S_PLAY_SPRING or p.mo.state == S_PLAY_FALL)
	and p.spintics == 1
	and p.sprung
	and not (p.charflags & SF_NOJUMPDAMAGE)
		p.mo.state = S_PLAY_ROLL
		p.pflags = $|PF_JUMPED
		p.pflags = $ & ~PF_THOKKED
		P_SpawnThokMobj(p)
		S_StartSound(p.mo, sfx_zoom)
	end
	end
end)

local function floorspritering(p)
	local frickinring = P_SpawnMobj(p.mo.x,p.mo.y,p.mo.z,MT_THOK)
	frickinring.state = S_TGRING
	frickinring.angle = p.drawangle+ANGLE_90
	frickinring.scale = p.mo.scale-FRACUNIT/4
	frickinring.destscale = p.mo.scale+FRACUNIT
	frickinring.fuse = 10
	frickinring.colorized = true
	frickinring.color = p.mo.color
	frickinring.renderflags = $|RF_FLOORSPRITE
	if (p.mo.eflags & MFE_VERTICALFLIP)
		frickinring.flags2 = $|MF2_OBJECTFLIP
	end
end

addHook("PlayerThink", function(p)
	if p.mo and p.mo.valid
	if p.trickhold == nil
		p.trickhold = false
		p.trickangle = 0
	end
	if p.mo and p.mo.valid
	and p.playerstate == PST_LIVE
	and p.sprung
	and not p.powers[pw_carry]
	and p.mo.skin ~= "adventuresonic"
	and p.mo.skin ~= "takisthefox"
	and p.c1tics == 1
	and (p.mo.state == S_PLAY_SPRING or p.mo.state == S_PLAY_FALL)
		p.sprung = false
		p.mo.state = S_PLAY_TRICKROLL
	end
	if p.mo.state == S_PLAY_TRICKROLL
		p.trickhold = true
	end
	if p.trickhold
		p.mo.momx = 0
		p.mo.momy = 0
		p.mo.momz = 0
	end
	if p.trickhold
	and p.mo.state ~= S_PLAY_TRICKROLL
	and p.mo.state ~= S_PLAY_TRICKFALL
		p.trickhold = false
	end
	if p.trickhold
	and p.mo.state == S_PLAY_TRICKFALL
		if not p.powers[pw_sneakers]
			p.trickhold = false
			S_StartSound(p.mo, sfx_advtr)
			P_InstaThrust(p.mo, p.mo.angle, p.normalspeed+(3*FU))
		else
			p.trickhold = false
			S_StartSound(p.mo, sfx_advtr)
			P_InstaThrust(p.mo, p.mo.angle, 54*FU)
		end
	end
	if p.mo.state == S_PLAY_TRICKFALL
		p.drawangle = p.trickangle
		p.trickangle = $-ANGLE_45
	end
	if p.sprung
	and p.jumptics == 1
	and (p.mo.state == S_PLAY_SPRING or p.mo.state == S_PLAY_FALL)
	and p.mo.skin ~= "adventuresonic"
		p.sprung = false
		S_StartSound(p.mo, sfx_advtr)
		floorspritering(p)
		p.mo.state = S_PLAY_JUMP
		P_SetPlayerMomZ(p, 15*FU, 7*FU)
		p.pflags = $|PF_JUMPED
		p.pflags = $ & ~PF_THOKKED
	end
	end
end)

addHook("PlayerThink", function(p)
	if p.mo and p.mo.valid
	local trickwaveoffset = FixedMul(FixedMul(p.mo.scale, p.shieldscale), 7)*65536
	states[S_TRICKWAVE1].var1 = trickwaveoffset
	states[S_TRICKWAVE2].var1 = trickwaveoffset
	states[S_TRICKWAVE3].var1 = trickwaveoffset
	states[S_TRICKWAVE4].var1 = trickwaveoffset
	states[S_TRICKWAVE5].var1 = trickwaveoffset
	states[S_TRICKWAVE6].var1 = trickwaveoffset
	states[S_TRICKWAVE7].var1 = trickwaveoffset
	states[S_TRICKWAVE8].var1 = trickwaveoffset
		if p.mo.state == S_PLAY_TRICKFALL
		and not p.trickwave
			p.trickwave = P_SpawnMobj(p.mo.x,p.mo.y,p.mo.z,MT_SPRINGTRICKWAVE)
			p.trickwave.target = p.mo
			p.trickwave.scale = FixedMul(p.shieldscale, p.mo.scale)+FU-FU/3
			p.trickwave.dispoffset = 50
		elseif p.mo.state ~= S_PLAY_TRICKFALL
		and p.trickwave and p.trickwave.valid
			P_RemoveMobj(p.trickwave)
			p.trickwave = nil
		end
	end
end)

addHook("PlayerCanDamage", function(p)
	if p.mo.state == S_PLAY_TRICKFALL
		return true
	end
end)